(* recherche de processus cach pour noyau 2.4
   Ecrit en Dcembre 2003, license GPL
   Franois Boisson, francois@boisson.homeip.net *)

#open "sys";;
#open "unix";;
#open "format";;
chdir "/proc";;
(* test si le fichier f existe *)
let test_fichier f =
try ((close_in (open_in f));true) with
_ -> false;;

(* boolen "noyau = 2.6" *)
let nouveau_noyau = test_fichier "1/task";;

(* liste des fichiers du repertoire s *)
let liste_repertoire s =
	 let c = (opendir s)
  in
  let res = ref [] in
  let rec boucle () =
      try (res:=(readdir c)::!res;boucle ()) with _-> ((closedir c);!res)
      in boucle ();;

(* s commence par un chiffre *)
let selection s = let c= int_of_char s.[0] in (c >= 48) && (c <= 57);;

(* liste des pids visibles *)
let liste_totale () = 
if nouveau_noyau then (flat_map 
     (function s -> if (selection s) then (liste_repertoire (s^"/task"))
       else []) (liste_repertoire "."))
else liste_repertoire ".";;


(* Truc beau  la Loick *)
let curseur = ref 0;;


let tableau = [|"|"; "/"; "-"; "\\"; "|"|];;

let beau () = 
    print_string (
    (tableau.((curseur:=((succ !curseur) mod 4);!curseur)))^"\b");
    print_flush ();;

(*
let beau N  =
    print_string  (string_of_int ((!curseur / N) mod 10));
    curseur:=(succ !curseur) mod (10*N);
    if (!curseur mod N = 0) then print_string "\r";
    print_flush ();;
*)

(* un choua mgalo *)
print_string "Recherche de processus cachs F.Boisson Dec2003";;
print_newline ();;


(* bazar *)
let total = ref 0 in
(
print_string "...";
for i = 1 to 65535 do
  let si = (string_of_int i) in
      if ((test_fichier si) && (beau (); not mem si (liste_totale ()))) then (
	total := !total +1;
	print_string "Processus cach :";
	print_int i;
	print_newline ();
	print_string "Environnement:\n";
	print_newline ();
	if nouveau_noyau
	then
	  (
	  (function _ -> ()) (system_command ("cat ./"^si^"/task/"^si^"/environ"));
	  print_newline ();
	  print_string "Ligne de commande:\n";
	  print_newline ();
	  (function _ -> ()) (system_command ("cat ./"^si^"/task/"^si^"/cmdline"));)
	else
	  (
	  (function _ -> ()) (system_command ("cat ./"^si^"/environ"));
	  print_newline ();
	  print_string "Ligne de commande:\n";
	  print_newline ();
	  (function _ -> ()) (system_command ("cat ./"^si^"/cmdline"));
	  );
	print_newline ();
	print_string "...";
	)
done;
    
    print_newline ();
    print_int !total;
    print_string " processus cach(s) trouv(s)";
    print_newline ();
    );;
